| TagLib 1.13 |  |

Public Member Functions | Protected Member Functions | List of all members
TagLib::Ogg::File Class Reference

An implementation of TagLib::File with some helpers for Ogg based formats. More...

`#include <oggfile.h>`

Inheritance diagram for TagLib::Ogg::File:
[legend]
Collaboration diagram for TagLib::Ogg::File:
[legend]

## Public Member Functions
virtual | ~File ()
ByteVector | packet (unsigned int i)
void | setPacket (unsigned int i, const ByteVector &p)
const PageHeader * | firstPageHeader ()
const PageHeader * | lastPageHeader ()
virtual bool | save ()
Public Member Functions inherited from TagLib::File
virtual | ~File ()
FileName | name () const
virtual Tag * | tag () const =0
PropertyMap | properties () const
void | removeUnsupportedProperties (const StringList &properties)
PropertyMap | setProperties (const PropertyMap &properties)
virtual AudioProperties * | audioProperties () const =0
virtual bool | save ()=0
ByteVector | readBlock (unsigned long length)
void | writeBlock (const ByteVector &data)
long | find (const ByteVector &pattern, long fromOffset=0, const ByteVector &before=ByteVector())
long | rfind (const ByteVector &pattern, long fromOffset=0, const ByteVector &before=ByteVector())
void | insert (const ByteVector &data, unsigned long start=0, unsigned long replace=0)
void | removeBlock (unsigned long start=0, unsigned long length=0)
bool | readOnly () const
bool | isOpen () const
bool | isValid () const
void | seek (long offset, Position p=Beginning)
void | clear ()
long | tell () const
long | length ()

## Protected Member Functions
| File (FileName file)
| File (IOStream *stream)
Protected Member Functions inherited from TagLib::File
| File (FileName file)
| File (IOStream *stream)
void | setValid (bool valid)
void | truncate (long length)

## Additional Inherited Members
Public Types inherited from TagLib::File
enum | Position { Beginning , Current , End }
enum | StripTags { StripNone , StripOthers }
enum | DuplicateTags { Duplicate , DoNotDuplicate }
Static Public Member Functions inherited from TagLib::File
static TAGLIB_DEPRECATED bool | isReadable (const char *file)
static TAGLIB_DEPRECATED bool | isWritable (const char *name)
Static Protected Member Functions inherited from TagLib::File
static unsigned int | bufferSize ()

## Detailed Description

An implementation of TagLib::File with some helpers for Ogg based formats.

This is an implementation of Ogg file page and packet rendering and is of use to Ogg based formats. While the API is small this handles the non-trivial details of breaking up an Ogg stream into packets and makes these available (via subclassing) to the codec meta data implementations.

## Constructor & Destructor Documentation

## ◆ ~File()

virtual TagLib::Ogg::File::~File | ( |  | ) |
| virtual

Destroys this File instance.

Reimplemented from TagLib::File.

Reimplemented in TagLib::Ogg::FLAC::File, TagLib::Ogg::Opus::File, TagLib::Ogg::Speex::File, and TagLib::Ogg::Vorbis::File.

## ◆ File() [1/2]

TagLib::Ogg::File::File | ( | FileName | file | ) |
| protected

Constructs an Ogg file from file.

Note
  This constructor is protected since Ogg::File shouldn't be instantiated directly but rather should be used through the codec specific subclasses.

## ◆ File() [2/2]

TagLib::Ogg::File::File | ( | IOStream * | stream | ) |
| protected

Constructs an Ogg file from stream.

Note
  This constructor is protected since Ogg::File shouldn't be instantiated directly but rather should be used through the codec specific subclasses.
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.

## Member Function Documentation

## ◆ firstPageHeader()

const PageHeader * TagLib::Ogg::File::firstPageHeader | ( |  | ) |

Returns a pointer to the PageHeader for the first page in the stream or null if the page could not be found.

## ◆ lastPageHeader()

const PageHeader * TagLib::Ogg::File::lastPageHeader | ( |  | ) |

Returns a pointer to the PageHeader for the last page in the stream or null if the page could not be found.

## ◆ packet()

ByteVector TagLib::Ogg::File::packet | ( | unsigned int | i | ) |

Returns the packet contents for the i-th packet (starting from zero) in the Ogg bitstream.

Warning
  This requires reading at least the packet header for every page up to the requested page.

## ◆ save()

virtual bool TagLib::Ogg::File::save | ( |  | ) |
| virtual

Save the file and its associated tags. This should be reimplemented in the concrete subclasses. Returns true if the save succeeds.

Warning
  On UNIX multiple processes are able to write to the same file at the same time. This can result in serious file corruption. If you are developing a program that makes use of TagLib from multiple processes you must insure that you are only doing writes to a particular file from one of them.

Implements TagLib::File.

Reimplemented in TagLib::Ogg::FLAC::File, TagLib::Ogg::Opus::File, TagLib::Ogg::Speex::File, and TagLib::Ogg::Vorbis::File.

## ◆ setPacket()

void TagLib::Ogg::File::setPacket | ( | unsigned int | i,
|  | const ByteVector & | p
| ) |  |

Sets the packet with index i to the value p.

The documentation for this class was generated from the following file:

- oggfile.h